//
//  MATCCalculationOperation.m
//  ThreadingExample
//
//  Created by Brad Larson on 3/3/2010.
//

#import "MATCCalculationOperation.h"
#include <unistd.h>

NSString *const kMATCCalculationStartedNotification = @"MATCCalculationDidStart";
NSString *const kMATCCalculationFinishedNotification = @"MATCCalculationDidFinish";

@implementation MATCCalculationOperation

#pragma mark -
#pragma mark Initialization and teardown

- (id)initWithCycles:(CGFloat)newCycles operationID:(NSInteger)newOperationID;
{
	if (!(self = [super init]))
		return nil;
	
	cycles = newCycles;
	operationID = newOperationID;
	
	return self;	
}

#pragma mark -
#pragma mark Notification methods

- (void)notifyAboutStartOfOperation;
{
	[[NSNotificationCenter defaultCenter] postNotificationName:kMATCCalculationStartedNotification object:[NSNumber numberWithInteger:operationID]];	
}

- (void)notifyAboutEndOfOperation;
{
	[[NSNotificationCenter defaultCenter] postNotificationName:kMATCCalculationFinishedNotification object:[NSNumber numberWithInteger:operationID]];	
}

#pragma mark -
#pragma mark Central processing

- (void)main
{	
	[self performSelectorOnMainThread:@selector(notifyAboutStartOfOperation) withObject:nil waitUntilDone:NO];

	// self.isCancelled
	for (NSUInteger currentCycle = 0; currentCycle < cycles; currentCycle++)
	{
		if ([self isCancelled])
			break;

		usleep(200);
	}
	
	
	[self performSelectorOnMainThread:@selector(notifyAboutEndOfOperation) withObject:nil waitUntilDone:NO];
}

@end
