//
//  MATCOperations.m
//  ThreadingExample
//
//  Created by Brad Larson on 11/8/2010.
//

#import "MATCGCD.h"
#import "MATCCalculationOperation.h"
#include <unistd.h>

@implementation MATCGCD

#pragma mark -
#pragma mark Initialization and teardown

- (void)viewDidLoad 
{
    [super viewDidLoad];

	subtitles = [[NSMutableArray alloc] initWithObjects:@"Not started", @"Not started", @"Not started", @"Not started", @"Not started", @"Not started", nil];

	UIBarButtonItem *startButtonItem = [[UIBarButtonItem alloc] initWithTitle:@"Start" style:UIBarButtonItemStylePlain target:self action:@selector(startCalculation)];
	self.navigationItem.rightBarButtonItem = startButtonItem;
	[startButtonItem release];	
}

- (void)dealloc 
{
    [super dealloc];
}

#pragma mark -
#pragma mark Table view methods

- (NSInteger)numberOfSectionsInTableView:(UITableView *)tableView 
{
    return 1;
}


// Customize the number of rows in the table view.
- (NSInteger)tableView:(UITableView *)tableView numberOfRowsInSection:(NSInteger)section 
{
    return [subtitles count];;
}


// Customize the appearance of table view cells.
- (UITableViewCell *)tableView:(UITableView *)tableView cellForRowAtIndexPath:(NSIndexPath *)indexPath {
    
    static NSString *CellIdentifier = @"Cell";
    
    UITableViewCell *cell = [tableView dequeueReusableCellWithIdentifier:CellIdentifier];
    if (cell == nil) {
        cell = [[[UITableViewCell alloc] initWithStyle:UITableViewCellStyleSubtitle reuseIdentifier:CellIdentifier] autorelease];
    }
	
	cell.textLabel.text = [NSString stringWithFormat:@"Operation %d", indexPath.row];
	
	NSString *currentOperationState = [subtitles objectAtIndex:indexPath.row];
	cell.detailTextLabel.text = currentOperationState;
	if ([currentOperationState isEqualToString:@"Completed"])
	{
		cell.accessoryType = UITableViewCellAccessoryCheckmark;
	}
	else
	{
		cell.accessoryType = UITableViewCellAccessoryNone;
	}
    
    return cell;
}

#pragma mark -
#pragma mark Calculation methods

- (IBAction)startCalculation;
{
	dispatch_queue_t main_queue = dispatch_get_main_queue();
	
	// The block we'll reuse for our parallel calculation example
	void (^runLoopingCalculation)(int, int) = ^(int cycles, int indexOfOperation) 
	{
		dispatch_async(main_queue, ^{
			[subtitles removeObjectAtIndex:indexOfOperation];
			[subtitles insertObject:@"Executing" atIndex:indexOfOperation];
			
			NSIndexPath *updatedIndexPath = [NSIndexPath indexPathForRow:indexOfOperation inSection:0];
			[self.tableView reloadRowsAtIndexPaths:[NSArray arrayWithObject:updatedIndexPath] withRowAnimation:UITableViewRowAnimationNone];			
		});
		
		for (NSUInteger currentCycle = 0; currentCycle < cycles; currentCycle++)
		{
			usleep(200);
		}

		dispatch_async(main_queue, ^{
			[subtitles removeObjectAtIndex:indexOfOperation];
			[subtitles insertObject:@"Completed" atIndex:indexOfOperation];
			
			NSIndexPath *updatedIndexPath = [NSIndexPath indexPathForRow:indexOfOperation inSection:0];
			[self.tableView reloadRowsAtIndexPaths:[NSArray arrayWithObject:updatedIndexPath] withRowAnimation:UITableViewRowAnimationNone];
		});
	};
	
	
	dispatch_queue_t queue = dispatch_get_global_queue(DISPATCH_QUEUE_PRIORITY_DEFAULT, 0);
	//dispatch_queue_t queue = dispatch_queue_create("edu.matcmadison.myapplication.calculationQueue", NULL);
//	dispatch_retain(queue);
	
/*	dispatch_async(queue, ^{
		dispatch_apply(6, queue, ^(size_t i) {
			runLoopingCalculation(10000, i);
		});
	});*/
	
	dispatch_async(queue, ^{
		runLoopingCalculation(10000, 0);
	});
	dispatch_async(queue, ^{
		runLoopingCalculation(10000, 1);
	});
	dispatch_async(queue, ^{
		runLoopingCalculation(10000, 2);
	});
	dispatch_async(queue, ^{
		runLoopingCalculation(10000, 3);
	});
	dispatch_async(queue, ^{
		runLoopingCalculation(10000, 4);
	});
	dispatch_async(queue, ^{
		runLoopingCalculation(10000, 5);
	});
	
//	dispatch_release(queue);
}

@end

